Don't use dpdk dev packages - weekly, func and perf jobs
[csit.git] / bootstrap-ubuntu.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 export DEBIAN_FRONTEND=noninteractive
21 sudo apt-get -y update
22 sudo apt-get -y install libpython2.7-dev python-virtualenv
23
24 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
25
26 VIRL_USERNAME=jenkins-in
27 VIRL_PKEY=priv_key
28 VIRL_SERVER_STATUS_FILE="status"
29 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
30
31 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
32
33 VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
34 VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
35
36 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
37
38 TEST_GROUPS=("l2bd,dhcp,gre,honeycomb,l2xc,lisp,softwire" "cop,telemetry,ipsec,ipv6,rpf,tap,vrf" "fds,iacl,ipv4,policer,vlan,vxlan")
39 SUITE_PATH="tests.func"
40
41 # Create tmp dir
42 mkdir ${SCRIPT_DIR}/tmp
43
44 # Use tmp dir to store log files
45 LOG_PATH="${SCRIPT_DIR}/tmp"
46
47 # Use tmp dir for tarballs
48 export TMPDIR="${SCRIPT_DIR}/tmp"
49
50 SHARED_MEMORY_PATH="/run/shm"
51
52 function ssh_do() {
53     echo
54     echo "### "  ssh $@
55     ssh ${SSH_OPTIONS} $@
56 }
57
58 rm -f ${VIRL_PKEY}
59 cat > ${VIRL_PKEY} <<EOF
60 -----BEGIN RSA PRIVATE KEY-----
61 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
62 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
63 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
64 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
65 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
66 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
67 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
68 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
69 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
70 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
71 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
72 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
73 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
74 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
75 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
76 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
77 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
78 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
79 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
80 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
81 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
82 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
83 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
84 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
85 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
86 -----END RSA PRIVATE KEY-----
87 EOF
88 chmod 600 ${VIRL_PKEY}
89
90 #
91 # Pick a random host from the array of VIRL servers for every test set run
92 # and attempt to reach it and verify it's status.
93 #
94 # The server must be reachable and have a "status" file with
95 # the content "PRODUCTION" to be selected.
96 #
97 # If the server is not reachable or does not have the correct
98 # status remove it from the array and start again.
99 #
100 # Abort if there are no more servers left in the array.
101 #
102 for index in "${!TEST_GROUPS[@]}"; do
103     VIRL_SERVER[${index}]=""
104     while [[ ! "${VIRL_SERVER[${index}]}" ]]; do
105         num_hosts=${#VIRL_SERVERS[@]}
106         if [ $num_hosts == 0 ]
107         then
108             echo "No more VIRL candidate hosts available, failing."
109             exit 127
110         fi
111         element=$[ $RANDOM % $num_hosts ]
112         virl_server_candidate=${VIRL_SERVERS[$element]}
113         virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
114         echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
115         if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
116         then
117             # Candidate is in good status. Select this server.
118             VIRL_SERVER[${index}]="$virl_server_candidate"
119         else
120             # Candidate is in bad status. Remove from array.
121             VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
122         fi
123     done
124 done
125
126 echo "Selected VIRL servers: ${VIRL_SERVER[@]}"
127
128 # Temporarily download VPP and DPDK packages from nexus.fd.io
129 DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
130 VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
131 VPP_CLASSIFIER="-deb"
132 if [ "${#}" -ne "0" ]; then
133     arr=(${@})
134     echo ${arr[0]}
135     # Download DPDK parts not included in dpdk plugin of vpp build
136     wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
137 else
138     rm -f *.deb
139     VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
140     wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
141     wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
142     wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
143     wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
144     wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
145     wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
146 fi
147
148 VPP_DEBS=(*.deb)
149 echo ${VPP_DEBS[@]}
150 VIRL_DIR_LOC="/tmp"
151 VPP_DEBS_FULL=(${VPP_DEBS[@]})
152
153 # Prepend directory location at remote host to deb file list
154 for index in "${!VPP_DEBS_FULL[@]}"; do
155     VPP_DEBS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_DEBS_FULL[${index}]}
156 done
157
158 echo "Updated file names: " ${VPP_DEBS_FULL[@]}
159
160 cat ${VIRL_PKEY}
161
162 # Copy the files to VIRL hosts
163 DONE=""
164 for index in "${!VIRL_SERVER[@]}"; do
165     # Do not copy files in case they have already been copied to the VIRL host
166     [[ "${DONE[@]}" =~ "${VIRL_SERVER[${index}]}" ]] && copy=0 || copy=1
167
168     if [ "${copy}" -eq "0" ]; then
169         echo "VPP deb files have already been copied to the VIRL host ${VIRL_SERVER[${index}]}"
170     else
171         scp ${SSH_OPTIONS} *.deb \
172         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
173
174         result=$?
175         if [ "${result}" -ne "0" ]; then
176             echo "Failed to copy VPP deb files to VIRL host ${VIRL_SERVER[${index}]}"
177             echo ${result}
178             exit ${result}
179         else
180             echo "VPP deb files successfully copied to the VIRL host ${VIRL_SERVER[${index}]}"
181         fi
182         DONE+=(${VIRL_SERVER[${index}]})
183     fi
184 done
185
186 # Start a simulation on VIRL server
187
188 function stop_virl_simulation {
189     for index in "${!VIRL_SERVER[@]}"; do
190         ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}\
191             "stop-testcase ${VIRL_SID[${index}]}"
192     done
193 }
194
195 # Upon script exit, cleanup the simulation execution
196 trap stop_virl_simulation EXIT
197
198 for index in "${!VIRL_SERVER[@]}"; do
199     echo "Starting simulation nr. ${index} on VIRL server ${VIRL_SERVER[${index}]}"
200     VIRL_SID[${index}]=$(ssh ${SSH_OPTIONS} \
201         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]} \
202         "start-testcase -c ${VIRL_TOPOLOGY} -r ${VIRL_RELEASE} ${VPP_DEBS_FULL[@]}")
203     retval=$?
204     if [ ${retval} -ne "0" ]; then
205         echo "VIRL simulation start failed on ${VIRL_SERVER[${index}]}"
206         exit ${retval}
207     fi
208     if [[ ! "${VIRL_SID[${index}]}" =~ session-[a-zA-Z0-9_]{6} ]]; then
209         echo "No VIRL session ID reported."
210         exit 127
211     fi
212     echo "VIRL simulation started on ${VIRL_SERVER[${index}]}"
213
214     ssh_do ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}\
215      cat /scratch/${VIRL_SID[${index}]}/topology.yaml
216
217     # Download the topology file from VIRL session and rename it
218     scp ${SSH_OPTIONS} \
219         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:/scratch/${VIRL_SID[${index}]}/topology.yaml \
220         topologies/enabled/topology${index}.yaml
221
222     retval=$?
223     if [ ${retval} -ne "0" ]; then
224         echo "Failed to copy topology file from VIRL simulation nr. ${index} on VIRL server ${VIRL_SERVER[${index}]}"
225         exit ${retval}
226     fi
227 done
228
229 echo ${VIRL_SID[@]}
230
231 virtualenv --system-site-packages env
232 . env/bin/activate
233
234 echo pip install
235 pip install -r ${SCRIPT_DIR}/requirements.txt
236
237 for index in "${!VIRL_SERVER[@]}"; do
238     pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
239               -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
240               -d ${SCRIPT_DIR}/topologies/enabled/topology${index}.yaml \
241               -vvv
242     if [ "$?" -ne "0" ]; then
243         echo "Topology${index} schema validation failed."
244         echo "However, the tests will start."
245     fi
246 done
247
248 function run_test_set() {
249     set +x
250     OLDIFS=$IFS
251     IFS=","
252     nr=$(echo $1)
253     rm -f ${LOG_PATH}/test_run${nr}.log
254     exec &> >(while read line; do echo "$(date +'%H:%M:%S') $line" \
255      >> ${LOG_PATH}/test_run${nr}.log; done;)
256     suite_str=""
257     for suite in ${TEST_GROUPS[${nr}]}; do
258         suite_str="${suite_str} --suite ${SUITE_PATH}.${suite}"
259     done
260     IFS=$OLDIFS
261
262     echo "PYTHONPATH=`pwd` pybot -L TRACE -W 136\
263         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology${nr}.yaml \
264         ${suite_str} \
265         --include vm_envAND3_node_single_link_topo \
266         --include vm_envAND3_node_double_link_topo \
267         --exclude PERFTEST \
268         --exclude SKIP_PATCH \
269         --noncritical EXPECTED_FAILING \
270         --output ${LOG_PATH}/log_test_set_run${nr} \
271         tests/"
272
273     PYTHONPATH=`pwd` pybot -L TRACE -W 136\
274         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology${nr}.yaml \
275         ${suite_str} \
276         --include vm_envAND3_node_single_link_topo \
277         --include vm_envAND3_node_double_link_topo \
278         --exclude PERFTEST \
279         --exclude SKIP_PATCH \
280         --noncritical EXPECTED_FAILING \
281         --output ${LOG_PATH}/log_test_set_run${nr} \
282         tests/
283
284     local_run_rc=$?
285     echo ${local_run_rc} > ${SHARED_MEMORY_PATH}/rc_test_run${nr}
286     set -x
287 }
288
289 set +x
290 # Send to background an instance of the run_test_set() function for each number,
291 # record the pid.
292 for index in "${!VIRL_SERVER[@]}"; do
293     run_test_set ${index} &
294     pid=$!
295     echo "Sent to background: Test_set${index} (pid=$pid)"
296     pids[$pid]=$index
297 done
298
299 echo
300 echo -n "Waiting..."
301
302 # Watch the stable of background processes.
303 # If a pid goes away, remove it from the array.
304 while [ -n "${pids[*]}" ]; do
305     for i in $(seq 0 9); do
306         sleep 1
307         echo -n "."
308     done
309     for pid in "${!pids[@]}"; do
310         if ! ps "$pid" >/dev/null; then
311             echo -e "\n"
312             echo "Test_set${pids[$pid]} with PID $pid finished."
313             unset pids[$pid]
314         fi
315     done
316     if [ -z "${!pids[*]}" ]; then
317         break
318     fi
319     echo -n -e "\nStill waiting for test set(s): ${pids[*]} ..."
320 done
321
322 echo
323 echo "All test set runs finished."
324 echo
325
326 set -x
327
328 RC=0
329 for index in "${!VIRL_SERVER[@]}"; do
330     echo "Test_set${index} log:"
331     cat ${LOG_PATH}/test_run${index}.log
332     RC_PARTIAL_RUN=$(cat ${SHARED_MEMORY_PATH}/rc_test_run${index})
333     RC=$((RC+RC_PARTIAL_RUN))
334     rm -f ${SHARED_MEMORY_PATH}/rc_test_run${index}
335     rm -f ${LOG_PATH}/test_run${index}.log
336     echo
337 done
338
339 # Log the final result
340 if [ "${RC}" -eq "0" ]; then
341     set +x
342     echo
343     echo "========================================================================================================================================"
344     echo "Final result of all test loops:                                                                                                 | PASS |"
345     echo "All critical tests have passed."
346     echo "========================================================================================================================================"
347     echo
348     set -x
349 else
350     if [ "${RC}" -eq "1" ]; then
351         HLP_STR="test has"
352     else
353         HLP_STR="tests have"
354     fi
355     set +x
356     echo
357     echo "========================================================================================================================================"
358     echo "Final result of all test loops:                                                                                                 | FAIL |"
359     echo "${RC} critical ${HLP_STR} failed."
360     echo "========================================================================================================================================"
361     echo
362     set -x
363 fi
364
365 echo Post-processing test data...
366
367 partial_logs=""
368 for index in "${!VIRL_SERVER[@]}"; do
369     partial_logs="${partial_logs} ${LOG_PATH}/log_test_set_run${index}.xml"
370 done
371
372 # Rebot output post-processing
373 rebot --noncritical EXPECTED_FAILING \
374       --output output.xml ${partial_logs}
375
376 # Remove unnecessary log files
377 rm -f ${partial_logs}
378
379 echo Post-processing finished.
380
381 if [ ${RC} -eq 0 ]; then
382     RETURN_STATUS=0
383 else
384     RETURN_STATUS=1
385 fi
386
387 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.